// cPskPlot.h
// ----------------------------------------------------------------------------
// Copyright (C) 2018
//              David Freese, W1HKJ
//
// This file is part of pskmeter.
//
// pskmeter is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
// pskmeter is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
// ----------------------------------------------------------------------------

#ifndef cPskPlot_H
#define cPskPlot_H

#if defined(WIN32) && !defined(__CYGWIN__)
#  include <direct.h>
#else
#  include <unistd.h>
#endif

#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Value_Slider.H>
#include <FL/Fl_Counter.H>
#include <FL/fl_draw.H>
#include <FL/math.h>
#include <stdio.h>
#include <stdlib.h>

#include "pskdata.h"

class cScopeTimePlot : public Fl_Widget {
  double sinval31[2*NUMPTS + 1];
  double sinval63[2*NUMPTS + 1];
  Cpskdata *data;
public:
  cScopeTimePlot(int X,int Y,int W,int H, const char *lbl) : Fl_Widget(X,Y,W,H) {
    box( FL_BORDER_FRAME );
    for (int i = 0; i <= 2*NUMPTS; i++) {
      sinval31[i] = sin(6.2831385307*i/(2*NUMPTS));
      sinval63[i] = sin(6.2831385307*i/NUMPTS);
    }
    data = 0;
  }
  cScopeTimePlot(int X,int Y,int W,int H) : Fl_Widget(X,Y,W,H) {
    box( FL_BORDER_FRAME );
    for (int i = 0; i <= 2*NUMPTS; i++) {
      sinval31[i] = sin(6.2831385307*i/(2*NUMPTS));
      sinval63[i] = sin(6.2831385307*i/NUMPTS);
    }
    data = 0;
  }
  void end() {};
  void setData (Cpskdata *d) {data = d;};
  void draw();
};

class cScopeFFTPlot : public Fl_Widget {
  Cpskdata *data;
public:
  cScopeFFTPlot(int X,int Y,int W,int H, const char *lbl) : Fl_Widget(X,Y,W,H) {
    box( FL_BORDER_FRAME );
    data = 0;
  }
  cScopeFFTPlot(int X, int Y, int W, int H): Fl_Widget(X,Y,W,H) {
	  box (FL_BORDER_FRAME);
	  data = 0;
  }
  void end() {};
  void setData (Cpskdata *d) {data = d;};
  void draw();
};

#endif
