// ----------------------------------------------------------------------------
// Copyright (C) 2018
//              David Freese, W1HKJ
//
// This file is part of pskmeter.
//
// pskmeter is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
// pskmeter is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
// ----------------------------------------------------------------------------

#ifndef _SUPPORT_H_
#define _SUPPORT_H_

#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#ifdef __WIN32__
#include <process.h>
#endif

#include <FL/fl_ask.H>
#include <FL/Fl_Help_Dialog.H>

#include "config.h"
#include "serial.h"
#include "pskdata.h"
#include "pskscope.h"

extern Fl_Double_Window *pskscope_dialog;

extern void readConfigFile();
extern void cbSampleTimer(void *);
extern void readdata();

extern Fl_Help_Dialog *help;
extern Fl_Window *about;
extern Fl_Double_Window *wConfig;
extern Fl_Double_Window *wSimulation;

extern Cserial   *pskserial;
extern Cpskdata  *pskdata;

extern bool bViewScope;
extern bool bQRP;
extern bool bAutoDrive;
extern bool bTestmode;
extern bool bEnabled;

extern double sampletime;
extern double saveVol;
extern double err;

extern int  iNbrCommPorts;
extern int  iCommPort;
extern int testmode;

extern char szCommPort[];
extern char szVersion[];
extern char progdir[];

extern bool testMeter();
extern bool initCommPort();
extern void initProgram(void *d);
extern void testdata();
extern void readdata();
extern void cbSampleTimer(void* d);
extern void clean_exit();

extern void cb_mnuExit(Fl_Menu_* m, void* d);
extern void cb_mnuConfig(Fl_Menu_* m, void* d);
extern void cb_mnuContext(Fl_Menu_* m, void* d);
extern void cb_mnu05sec(Fl_Menu_* m, void* d);
extern void cb_mnu10sec(Fl_Menu_* m, void* d);
extern void cb_mnu20sec(Fl_Menu_* m, void* d);
extern void cb_Mode(PSKMODE d);
extern void cb_mnuConfigGeneral(Fl_Menu_* m, void* d);
extern void setParameters();
extern void writeConfigFile();
extern void readConfigFile();
extern void cb_btnConfigOK(Fl_Button *b, void * d);
extern void cb_btnConfigSave(Fl_Button *b, void * d);
extern void cb_btnConfigCancel(Fl_Button *b, void *d);
extern void cb_wMain(Fl_Double_Window *w, void *d);

extern void cb_mnuAbout(Fl_Menu_ *mnu, void *d);
extern void cb_mnuHelpContext (Fl_Menu_ *mnu, void *d);
extern void cb_Active(Fl_Check_Button *btn, void *d);

#endif
