// ----------------------------------------------------------------------------
// Copyright (C) 2018
//              David Freese, W1HKJ
//
// This file is part of pskmeter.
//
// pskmeter is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
// pskmeter is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
// ----------------------------------------------------------------------------

#ifndef SOCK_XML_IO_H
#define SOCK_XML_IO_H

#include <string>
#include <queue>
#include "threads.h"

struct FREQMODE { long freq; std::string mode;};

extern pthread_mutex_t mutex_xmlrpc;

extern std::queue<bool> quePTT;
extern std::queue<FREQMODE> xml_queue;

extern bool wait_query;
extern bool fldigi_online;
extern bool run_digi_loop;
extern bool bypass_digi_loop;
extern bool rig_reset;

extern void open_rig_xmlrpc();
extern void close_rig_xmlrpc();
extern void xml_put_freq(int);
extern void xml_put_name();
extern void xml_put_ptt(bool);
extern void xml_put_modes();
extern void xml_put_mode(std::string);
extern void xml_put_sideband(std::string);
extern void xml_put_info();

extern void digi_loop(void *);

#endif
