// Class definition for psk plot

#include "pskplot.h"

double lvals[10] = {0.0, -0.3, -0.48, -0.6, -0.78, -0.85, -0.85, -0.9, -0.95, -1.0};

void cScopeFFTPlot::draw() {
	int W = w(), H = h();
	int Y = y(), X = x();
	double q;
	fl_clip(x(),y(),w(),h());
	fl_color(FL_BLACK);
	fl_rectf(x(),y(),w(),h());
	fl_push_matrix();

	fl_color(FL_WHITE);

// set up translate & scale for 0,0 at upper left
// xscale of 0 to 6, yscale 0 to -3 (+0 to -60 db)

	fl_translate(X + 4 + (W-8)/2.0, Y + 4);
	fl_scale( (W-8)/17.0, -(H-8)/4.0 );

// draw axis & log scale
// x graticule
	for (int i = -8; i < 9; i++) {
			fl_begin_line();
			fl_vertex(i, -4);
			fl_vertex(i, 0);
			fl_end_line();
	}
// y graticule
	for (int i = 0; i < 4; i++) {
		for (int j = 0; j < 10; j++) {
			fl_begin_line();
				fl_vertex(-8, -i+lvals[j]);
				fl_vertex(8, -i+lvals[j]);
			fl_end_line();
		}
	}
// draw FFT lines
	if (data) {
		switch (data->IMDstat()) {
			case 2: fl_color(FL_RED); break;
			case 1: fl_color(FL_YELLOW); break;
			case 0:
			default: fl_color(FL_GREEN);
		}
		for (int i = 0, j = 1 ; i < 7; i++, j++ ) {
			q = log10(data->q[i]);
			if (q < -4.0) q = -4.0;
			fl_begin_polygon();
			fl_vertex (j-0.05,-4.0);
			fl_vertex (j-0.05, q);
			fl_vertex (j+0.05, q);
			fl_vertex (j+0.05,-4.0);
			fl_vertex (j-0.05,-4.0);
			fl_end_polygon();
			fl_begin_polygon();
			fl_vertex (-j-0.05,-4.0);
			fl_vertex (-j-0.05, q);
			fl_vertex (-j+0.05, q);
			fl_vertex (-j+0.05,-4.0);
			fl_vertex (-j-0.05,-4.0);
			fl_end_polygon();
		 }
	}

	fl_pop_matrix();
	fl_pop_clip();

}

void cScopeTimePlot::draw() {
	int W = w(), H = h();
	int Y = y(), X = x();
	fl_clip(x(),y(),w(),h());
	fl_color(FL_BLACK);
	fl_rectf(x(),y(),w(),h());
	fl_push_matrix();

	fl_color(FL_WHITE);
// set up translate & scale for 0,0 at middle left
	fl_translate(X + 4, Y + 4 + (H-8)/2);
	fl_scale( (W-8)/(NUMPTS * 2.0), -(H - 8)/2.0 );
// draw axis
	fl_begin_line();
		fl_vertex( 0, 0);
		fl_vertex( NUMPTS * 2, 0);
	fl_end_line();
	fl_begin_line();
		fl_vertex(0,-1);
		fl_vertex(0, 1);
	fl_end_line();
// draw ideal idle waveform
	if (data) {
		if (data->mode == PSK31) {
			for (int i = 1; i <= 2*NUMPTS; i++) {
				fl_begin_line();
				fl_vertex(i-1, sinval31[i-1]);
				fl_vertex(i,   sinval31[i]);
				fl_end_line();
			}
			for (int i = 1; i <= 2*NUMPTS; i++){
				fl_begin_line();
				fl_vertex(i-1, -sinval31[i-1]);
				fl_vertex(i,   -sinval31[i]);
				fl_end_line();
			}
		} else {
			for (int i = 1; i <= 2*NUMPTS; i++) {
				fl_begin_line();
				fl_vertex(i-1, sinval63[i-1]);
				fl_vertex(i,   sinval63[i]);
				fl_end_line();
			}
			for (int i = 1; i <= 2*NUMPTS; i++){
				fl_begin_line();
				fl_vertex(i-1, -sinval63[i-1]);
				fl_vertex(i,   -sinval63[i]);
				fl_end_line();
			}
		}
	}
// draw data lines
	if (data) {
		switch (data->IMDstat()) {
			case 2: fl_color(FL_RED); break;
			case 1: fl_color(FL_YELLOW); break;
			case 0:
			default: fl_color(FL_GREEN);
		}
		for (int i = 0; i < NUMPTS; i++) {
			fl_begin_line();
			fl_vertex (i*2, -data->normalized_vals[i]);
			fl_vertex (i*2, data->normalized_vals[i]);
			fl_end_line();
		}
	}

	fl_pop_matrix();
	fl_pop_clip();

}



